// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	authorizationv1 "github.com/openshift/api/authorization/v1"
	versioned "github.com/openshift/client-go/authorization/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/authorization/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/authorization/listers/authorization/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// RoleBindingRestrictionInformer provides access to a shared informer and lister for
// RoleBindingRestrictions.
type RoleBindingRestrictionInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.RoleBindingRestrictionLister
}

type roleBindingRestrictionInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewRoleBindingRestrictionInformer constructs a new informer for RoleBindingRestriction type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewRoleBindingRestrictionInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredRoleBindingRestrictionInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredRoleBindingRestrictionInformer constructs a new informer for RoleBindingRestriction type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredRoleBindingRestrictionInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.AuthorizationV1().RoleBindingRestrictions(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.AuthorizationV1().RoleBindingRestrictions(namespace).Watch(context.TODO(), options)
			},
		},
		&authorizationv1.RoleBindingRestriction{},
		resyncPeriod,
		indexers,
	)
}

func (f *roleBindingRestrictionInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredRoleBindingRestrictionInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *roleBindingRestrictionInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&authorizationv1.RoleBindingRestriction{}, f.defaultInformer)
}

func (f *roleBindingRestrictionInformer) Lister() v1.RoleBindingRestrictionLister {
	return v1.NewRoleBindingRestrictionLister(f.Informer().GetIndexer())
}
