// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	oauthv1 "github.com/openshift/api/oauth/v1"
	versioned "github.com/openshift/client-go/oauth/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/oauth/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/oauth/listers/oauth/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// UserOAuthAccessTokenInformer provides access to a shared informer and lister for
// UserOAuthAccessTokens.
type UserOAuthAccessTokenInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.UserOAuthAccessTokenLister
}

type userOAuthAccessTokenInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewUserOAuthAccessTokenInformer constructs a new informer for UserOAuthAccessToken type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewUserOAuthAccessTokenInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredUserOAuthAccessTokenInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredUserOAuthAccessTokenInformer constructs a new informer for UserOAuthAccessToken type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredUserOAuthAccessTokenInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.OauthV1().UserOAuthAccessTokens().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.OauthV1().UserOAuthAccessTokens().Watch(context.TODO(), options)
			},
		},
		&oauthv1.UserOAuthAccessToken{},
		resyncPeriod,
		indexers,
	)
}

func (f *userOAuthAccessTokenInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredUserOAuthAccessTokenInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *userOAuthAccessTokenInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&oauthv1.UserOAuthAccessToken{}, f.defaultInformer)
}

func (f *userOAuthAccessTokenInformer) Lister() v1.UserOAuthAccessTokenLister {
	return v1.NewUserOAuthAccessTokenLister(f.Informer().GetIndexer())
}
