// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	templatev1 "github.com/openshift/api/template/v1"
	versioned "github.com/openshift/client-go/template/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/template/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/template/listers/template/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// TemplateInstanceInformer provides access to a shared informer and lister for
// TemplateInstances.
type TemplateInstanceInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.TemplateInstanceLister
}

type templateInstanceInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewTemplateInstanceInformer constructs a new informer for TemplateInstance type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewTemplateInstanceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredTemplateInstanceInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredTemplateInstanceInformer constructs a new informer for TemplateInstance type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredTemplateInstanceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.TemplateV1().TemplateInstances(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.TemplateV1().TemplateInstances(namespace).Watch(context.TODO(), options)
			},
		},
		&templatev1.TemplateInstance{},
		resyncPeriod,
		indexers,
	)
}

func (f *templateInstanceInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredTemplateInstanceInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *templateInstanceInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&templatev1.TemplateInstance{}, f.defaultInformer)
}

func (f *templateInstanceInformer) Lister() v1.TemplateInstanceLister {
	return v1.NewTemplateInstanceLister(f.Informer().GetIndexer())
}
